'use strict';var vue=require('vue');function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}var script = /*#__PURE__*/vue.defineComponent({
  name: "RadialProgressVue3",
  // vue component name
  props: {
    width: {
      type: Number,
      default: 80
    },
    strokeWidth: {
      type: Number,
      default: 6
    },
    strokeColor: {
      type: String,
      default: "#2e5090"
    },
    innerStrokeColor: {
      type: String,
      default: "#ffaadd"
    },
    fillColor: {
      type: String,
      default: "#E6E6FA"
    },
    roundedStroke: {
      type: Boolean,
      default: false
    },
    showText: {
      type: Boolean,
      default: true
    },
    textColor: {
      type: String,
      default: "#222222"
    },
    fontWeight: {
      type: [String, Number],
      default: 900
    },
    fontSize: {
      type: Number,
      default: 12
    },
    showPercentSymbol: {
      type: Boolean,
      default: true
    },
    clockWise: {
      type: Boolean,
      default: true
    },
    percent: {
      type: Number,
      default: 42
    }
  },
  setup: function setup(props) {
    var radius = props.width / 2 - props.strokeWidth * 2;
    var circumference = 2 * Math.PI * radius;
    var offset = vue.computed(function () {
      if (props.clockWise) {
        return circumference - props.percent / 100 * circumference;
      } else {
        return circumference + props.percent / 100 * circumference;
      }
    });
    var roundedPercent = vue.computed(function () {
      return Math.round(props.percent);
    });
    return {
      radius: radius,
      circumference: circumference,
      offset: offset,
      roundedPercent: roundedPercent
    };
  }
});var _hoisted_1 = ["width", "height"];
var _hoisted_2 = ["cx", "cy", "r", "fill", "stroke", "stroke-width"];
var _hoisted_3 = ["cx", "cy", "r", "stroke", "stroke-width", "stroke-dasharray", "stroke-dashoffset", "stroke-linecap"];
var _hoisted_4 = ["fill"];
function render(_ctx, _cache, $props, $setup, $data, $options) {
  return vue.openBlock(), vue.createElementBlock("svg", {
    width: _ctx.width,
    height: _ctx.width
  }, [vue.createElementVNode("circle", {
    cx: _ctx.width / 2,
    cy: _ctx.width / 2,
    r: _ctx.radius,
    fill: _ctx.fillColor,
    stroke: _ctx.innerStrokeColor,
    "stroke-width": _ctx.strokeWidth
  }, null, 8, _hoisted_2), vue.createElementVNode("circle", {
    cx: _ctx.width / 2,
    cy: _ctx.width / 2,
    r: _ctx.radius,
    fill: "transparent",
    stroke: _ctx.strokeColor,
    "stroke-width": _ctx.strokeWidth,
    "stroke-dasharray": _ctx.circumference,
    "stroke-dashoffset": _ctx.offset,
    "stroke-linecap": _ctx.roundedStroke ? 'round' : 'butt',
    class: vue.normalizeClass(_ctx.$style.circle)
  }, null, 10, _hoisted_3), _ctx.showText ? (vue.openBlock(), vue.createElementBlock("text", {
    key: 0,
    x: "50%",
    y: "50%",
    fill: _ctx.textColor,
    style: vue.normalizeStyle({
      fontWeight: _ctx.fontWeight,
      fontSize: "".concat(_ctx.fontSize, "px")
    }),
    "dominant-baseline": "middle",
    "text-anchor": "middle"
  }, vue.toDisplayString(_ctx.roundedPercent) + vue.toDisplayString(_ctx.showPercentSymbol ? "%" : ""), 13, _hoisted_4)) : vue.createCommentVNode("", true)], 8, _hoisted_1);
}function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}var css_248z = "\n._circle_2cw8x_2 {\n  transform: rotate(-90deg);\n  transform-origin: center;\n\n  transition: 500ms stroke-dashoffset linear;\n}\n";
styleInject(css_248z);var style0 = {
  "circle": "_circle_2cw8x_2"
};var cssModules = script.__cssModules = {};
cssModules["$style"] = style0;
script.render = render;// Import vue component

// Default export is installable instance of component.
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),
var component = /*#__PURE__*/(function () {
  // Assign InstallableComponent type
  var installable = script; // Attach install function executed by Vue.use()

  installable.install = function (app) {
    app.component('RadialProgressVue3', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;
var namedExports=/*#__PURE__*/Object.freeze({__proto__:null,'default':component});// only expose one global var, with named exports exposed as properties of
// that global var (eg. plugin.namedExport)

Object.entries(namedExports).forEach(function (_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      exportName = _ref2[0],
      exported = _ref2[1];

  if (exportName !== 'default') component[exportName] = exported;
});module.exports=component;